---
title: Shapes from box values
slug: Web/CSS/CSS_Shapes/From_box_values
tags:
  - Boundaries
  - Boxes
  - CSS
  - CSS Shapes
  - Guide
  - Margins
  - border-box
  - border-radius
  - box values
  - content-box
  - float
  - margin-box
  - padding-box
  - shapes
---
<div>{{CSSRef}}</div>

<p class="summary">A straightforward way to create a shape is to use a value from the CSS Box Model. This article explains how to do this.</p>

<p>The <a href="https://drafts.csswg.org/css-shapes-1/#shapes-from-box-values">box values</a> allowable as a shape value are:</p>

<ul>
 <li><code>content-box</code></li>
 <li><code>padding-box</code></li>
 <li><code>border-box</code></li>
 <li><code>margin-box</code></li>
</ul>

<p>The <code>border-radius</code> values are also supported, this means that you can have something in your page with a curved border, and your shape can follow the created shape.</p>

<h2 id="CSS_box_model">CSS box model</h2>

<p>The values listed above correspond to the various parts of the CSS Box Model. A box in CSS has content, padding, border, and margin.</p>

<p><img alt="The Box Model consists of the margin, border, padding and content boxes." src="https://mdn.mozillademos.org/files/15845/box-model.png" style="height: 267px; width: 447px;"></p>

<p>By using Box Values for Shapes we can wrap our content around the edges defined by these values. In all of the examples below I am using an element which has padding, a border, and a margin defined in order that you can see the different ways in which content will flow.</p>

<h3 id="margin-box">margin-box</h3>

<p>The <code>margin-box</code> is the shape defined by the outside margin edge and includes the corner radius of the shape, should {{cssxref("border-radius")}} have been used in defining the element.</p>

<p>In the example below, we have a circular purple item which is a {{htmlelement("div")}} with a height, width, and background colour. The <code>border-radius</code> property has been used to create a circle by setting <code>border-radius: 50%</code>. As the element has a margin, you can see that the content is flowing around the circular shape and the margin applied to it.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/box/margin-box.html", '100%', 800)}}</p>

<h3 id="border-box">border-box</h3>

<p>The <code>border-box</code> value is the shape defined by the outside border edge. This shape follows all of the normal border radius shaping rules for the outside of the border. You still have a border, even if you have not used the CSS {{cssxref("border")}} property. In this case it will be the same as <code>padding-box</code>, the shape defined by the outside padding edge.</p>

<p>In the example below you can see how the text now follows the line created by the border. Change the border size and the content follows it.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/box/border-box.html", '100%', 800)}}</p>

<h3 id="padding-box">padding-box</h3>

<p>The <code>padding-box</code> value defines the shape enclosed by the outside padding edge. This shape follows all of the normal border radius shaping rules for the inside of the border. If you have no padding then <code>padding-box</code> is the same as <code>content-box</code>.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/box/padding-box.html", '100%', 800)}}</p>

<h3 id="content-box">content-box</h3>

<p>The <code>content-box</code> value defines the shape enclosed by the outside content edge. Each corner radius of this box is the larger of 0 or border-radius − border-width − padding. This Means that it is impossible to have a negative value here.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/box/content-box.html", '100%', 800)}}</p>

<h2 id="When_to_use_the_box_values">When to use the box values</h2>

<p>Using box values is a simple way to create shapes, however this is by nature only going to work with very simple shapes that can be defined using the well-supported <code>border-radius</code> property. The examples shown above show one such use case. You can create a circular shape using border-radius and then curve text around it.</p>

<p>You can create some interesting effects however with just this simple technique. In my final example of this section, I have floated two elements left and right, giving each a border-radius of 100% in the direction closest to the text.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/box/bottom-margin-box.html", '100%', 800)}}</p>

<p>For more complex shapes you will need to use one of the <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes">basic shapes</a> as a value, or define your Shape from an image as covered in other guides in this section.</p>
